Getting Started with Barcode Web Component
Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.
Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.
Quick start
- Install the package:
npm install smart-webcomponents
- Load the Barcode module (ES module script):
<script type="module" src="node_modules/smart-webcomponents/source/modules/smart.barcode.js"></script>
- Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):
<link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />
- Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host
div(you mount programmatically with appendTo):
Semantic element (id matches the selector in Smart()):
<smart-barcode id="barcode"></smart-barcode>
Host container (id matches appendTo on Smart.Barcode):
<div id="barcodeContainer"></div>
- Initialize after the module loads: define a const barcodeOptions object, then either bind with Smart('#barcode', ...) on the semantic tag or use new Smart.Barcode({ ...barcodeOptions, appendTo: '#barcodeContainer' }) on the host
div:
<script type="module"> import 'node_modules/smart-webcomponents/source/modules/smart.barcode.js'; const barcodeOptions = {}; // Option A - semantic <smart-barcode> with id="barcode" Smart('#barcode', class { get properties() { return barcodeOptions; } }); // Option B - host div id="barcodeContainer" // const barcodeInstance = new Smart.Barcode({ // ...barcodeOptions, // appendTo: '#barcodeContainer' // }); // Option C - constructor(selector, options), then append the returned element yourself // const myBarcode = new Smart.Barcode('#barcode', barcodeOptions); // document.body.appendChild(myBarcode); </script>
Uncomment Option B when you use the host
div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Barcode('#barcode', barcodeOptions) with appendChild, and document.createElement('smart-barcode') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components). - Serve the folder over HTTP (or use your bundler dev server) and open the page.
Runtime cookbook
Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Barcode({ ...options, appendTo: '#...' }); new Smart.Barcode('#barcode', barcodeOptions) plus appendChild on the returned element; and document.createElement('smart-barcode') then assigning options via .props or Object.assign on the element.
Constructor with a selector string and options, then append the returned element (for example const myBarcode = new Smart.Barcode('#barcode', barcodeOptions)):
const barcodeOptions = {};
const myBarcode = new Smart.Barcode('#barcode', barcodeOptions);
document.body.appendChild(myBarcode);
Create with document.createElement('smart-barcode'), assign properties (same as any custom element), then append:
const barcodeOptions = {};
const barcode = document.createElement('smart-barcode');
Object.assign(barcode, barcodeOptions);
document.body.appendChild(barcode);
Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):
import "../../source/modules/smart.barcode.js";
document.readyState === 'complete' ? init() : window.addEventListener('load', init);
function init() {
const barcodeOptions = {};
const barcode = new Smart.Barcode({
...barcodeOptions,
appendTo: '#barcodeContainer'
});
}
Demo
The barcode element supports a wide range of the most common barcode types available:
- PharmaCode
- CodaBar
- Code128A | Code128B | Code128C
- MSI | MSI10 | MSI11 | MSI1010 | MSI1110
- EAN8 | EAN13
- Code39
- Code93
<!DOCTYPE html>
<html lang="en">
<head>
<link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
<script type="text/javascript" src="../../source/modules/smart.barcode.js"></script>
</head>
<body>
<smart-barcodetype="pharmacode" value="12345"></smart-barcode>
<smart-barcode type="code128c" value="22481203"></smart-barcode>
<smart-barcode type="codabar" value="A2402B"></smart-barcode>
<smart-barcode type="code39" value="*1234*"></smart-barcode>
<smart-barcode type="code128a" value="EXAMPLE"></smart-barcode>
</body>
</html>
Demo
Appearance
The rendering mode is set using the renderAs property - svg(default) and canvas are supported.
The recommended rendering mode is svg as the image quality remains the same as the barcode is zoomed in.
<!DOCTYPE html>
<html lang="en">
<head>
<link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
<script type="text/javascript" src="../../source/modules/smart.barcode.js"></script>
</head>
<body>
<smart-barcode render-as="svg" type="codabar" value="A2402B"></smart-barcode>
<smart-barcode render-as="canvas" type="codabar" value="A2402B"></smart-barcode>
</body>
</html>
Demo
The barcode's color, background color and bar dimensions can be customized by their respective properties:
<smart-barcode value="A2402B" line-color="red" line-width="3" line-height="20" background-color="lightblue"></smart-barcode>
Demo
The label of the barcode can be set to visible or hidden with displayLabel. Its color, font, size, margins and position can be customized by their respective properties. When the barcode is rendered as svg, the label can also be customized with CSS.
<smart-barcode value="A2402B" ></smart-barcode>
Behavior
Every valid barcode can be exported to a downloadable file. The export method supports the following formats:
- svg
- png
- jpg
<script>
function exportBarcode(){
let barcode1 = document.getElementById('export-barcode');
barcode1.export('png', 'my-barcode');
}
</script>
<smart-barcode id="export-barcode" value="A2402B" label-position="top" label-font-size="30" label-color="orange" label-font="arial" line-color="orange"></smart-barcode>
<button onclick="exportBarcode()">Download</button>
Demo
Smart.BarCode contains a built-in validator, which depends on the barcode type.
In the case of a invalid value, the isValid method will return false and the invalid event will be triggered.
The invalid event.detail contains multiple values that can indicate the validity of the barcode:
- invalidCharacters - An array indicating the invalid characters.
- patternValidity - A boolean indicating the validity of the barcode pattern.
- lengthValidity - A boolean indicating the validity of the barcode length.
The demo below will output the illegal charcters of the barcode:
<!DOCTYPE html>
<html lang="en">
<head>
<link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
<script type="text/javascript" src="../../source/modules/smart.barcode.js"></script>
<script>
window.onload = function(){
var barcode2 = document.getElementById('invalid-barcode');
const OnInvalid = (event) => {
let invalidChars = event.detail.invalidCharacters;
document.getElementById("invalid-box").textContent+= invalidChars.join(' and ')
};
barcode2.addEventListener("invalid", OnInvalid);
}
function changeValue(){
barcode2 = document.getElementById('invalid-barcode');
barcode2.value = "A1230B@!"
}
</script>
</head>
<body>
<smart-barcode>Click Me</smart-barcode>
</body>
</html>
Demo
Append to the DOM:
const container = document.getElementById('barcode-container');
container.appendChild(barcode);
Remove from the DOM:
barcode.remove();
Set a property:
barcode.disabled = true; barcode.theme = 'dark';
Get a property value:
const isDisabled = barcode.disabled; const currentTheme = barcode.theme;
Invoke a method:
barcode.refresh(); barcode.focus();
Add event listener:
barcode.addEventListener('invalid', (event) => {
console.log('invalid triggered:', event.detail.invalidCharacters);
});
Remove event listener:
const handleBarcodeEvent = (event) => {
console.log('invalid triggered:', event.detail.invalidCharacters);
};
barcode.addEventListener('invalid', handleBarcodeEvent);
barcode.removeEventListener('invalid', handleBarcodeEvent);
Accessibility
The Barcode component follows WAI-ARIA best practices:
- Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
- ARIA roles - Appropriate roles and labels are applied automatically
- Focus management - Visible focus indicators for keyboard users
- Screen readers - State changes are announced to assistive technology
- High contrast - Supports Windows High Contrast Mode and forced colors
For custom labeling, set aria-label or aria-labelledby attributes on the component.
Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Barcode - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/barcode/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import BarcodeModule from smart-webcomponents-angular/barcode: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { BarcodeModule } from 'smart-webcomponents-angular/barcode';

4 Root component (standalone)

Add BarcodeModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { BarcodeComponent } from 'smart-webcomponents-angular/barcode';

import { BarcodeModule } from 'smart-webcomponents-angular/barcode';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ BarcodeModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('pharmacode', { read: BarcodeComponent, static: false }) pharmacode!: BarcodeComponent;
	@ViewChild('codabar', { read: BarcodeComponent, static: false }) codabar!: BarcodeComponent;
	@ViewChild('code128c', { read: BarcodeComponent, static: false }) code128c!: BarcodeComponent;
	@ViewChild('code128a', { read: BarcodeComponent, static: false }) code128a!: BarcodeComponent;
	@ViewChild('code128b', { read: BarcodeComponent, static: false }) code128b!: BarcodeComponent;
	@ViewChild('msi10', { read: BarcodeComponent, static: false }) msi10!: BarcodeComponent;
	@ViewChild('msi11', { read: BarcodeComponent, static: false }) msi11!: BarcodeComponent;
	@ViewChild('code39', { read: BarcodeComponent, static: false }) code39!: BarcodeComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    
    // no code

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-barcode as needed:

 <div class="container">
    <h3>The barcode element supports a wide range of the most common barcode types available</h3>
    <div class="underlined">Pharmacode:</div>
    <smart-barcode #pharmacode [type]="'pharmacode'" [value]="'1234'"></smart-barcode>
    <div class="underlined">Codabar:</div>
    <smart-barcode #codabar [type]="'codabar'" [value]="'A2402B'" ></smart-barcode>
    <div class="underlined">Code128 A | B | C:</div>
    <smart-barcode #code128c [type]="'code128c'" [value]="'22481203'"></smart-barcode>
    <smart-barcode #code128a [type]="'code128a'" [value]="'EXAMPLE'"></smart-barcode>
    <smart-barcode #code128b [type]="'code128b'" [value]="'example'"></smart-barcode>
    <br/>
    <div class="underlined">MSI 10 | 11:</div>
    <smart-barcode #msi10 [type]="'msi10'" [value]="'12345'"></smart-barcode>
    <smart-barcode #msi11 [type]="'msi11'" [value]="'67890'"></smart-barcode>
    <div class="underlined">Code39:</div>
    <smart-barcode #code39 [type]="'code39'" [value]="'*1234567AB*'" [lineWidth]="2" ></smart-barcode>
</div>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put BarcodeModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put BarcodeModule from smart-webcomponents-angular/barcode on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { BarcodeModule } from 'smart-webcomponents-angular/barcode';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, BarcodeModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Barcode component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Barcode Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/barcode/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from 'react';
import { Barcode } from 'smart-webcomponents-react/barcode';

const App = () => {
  return (
    <div className="container">
      <h3>The Barcode element supports a wide range of the most common Barcode types available</h3>

      <div>Pharmacode:</div>
      <Barcode id="pharma" type="pharmacode" value="1234" />

      <div>Codabar:</div>
      <Barcode type="codabar" value="A2402B" />

      <div>Code128 A | B | C:</div>
      <Barcode type="code128c" value="22481203" />
      <Barcode type="code128a" value="EXAMPLE" />
      <Barcode type="code128b" value="example" />

      <br />
      <div>MSI 10 | 11:</div>
      <Barcode type="msi10" value="12345" />
      <Barcode type="msi11" value="67890" />

      <div>Code39:</div>
      <Barcode type="code39" value="*1234567AB" lineWidth={2} />
    </div>
  );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Barcode, BarcodeProps } from 'smart-webcomponents-react/barcode';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Barcode component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.